
import java.applet.*;
import java.awt.*;

/////////////////////////////////////////////////////////////////
public class DustManager {


  private Dust dust[];                 // array of ufos

  int startNumOfDust = 0;
  int numOfDust = 0;
	int maxNumOfDust = 0;

  boolean playSound = false;         // initially no sound
  AudioClip expsound;                // sound clip of explosion

  static int width, height;          // applet dimensions

  // constructor
  public DustManager(int numOfDust, int maxNumOfDust, int width, int height,
  									 Image dustImages[], Image explodeImages[], Applet applet,
  									 AudioClip exp) {

		this.maxNumOfDust = maxNumOfDust;
		if(numOfDust > maxNumOfDust)
			numOfDust = maxNumOfDust;

    this.startNumOfDust = numOfDust;
    this.numOfDust = numOfDust;

    this.width = width;
    this.height =  height;

    dust = new Dust[maxNumOfDust];
    for (int i=0; i<dust.length; i++) {
      dust[i] = new Dust(dustImages, explodeImages, width, height,this,applet);
    }

    expsound = exp;
    newGame();
  }


  // allow the Dust class to communicate with the ship
  public void initialize(ShipManager sManager) {
    Dust.initialize(sManager);
  }

  // set dust at a random screen location
  private void initializePosition(Moveable m) {
    m.setPosition(Dust.getRand(width - 100)+50,
		  Dust.getRand(height - 150)+31);
  }

  // initialize parameters of new Game
  public void newGame() {
    this.numOfDust = startNumOfDust;  // start with start # of dust
                                     	//   on the screen

    for (int i=0; i<dust.length; i++) {
      initializePosition(dust[i]);
      if (i >= numOfDust) {          // suspend dust objects
                                     //   above start level
				dust[i].suspend();
      }
    }
  }


  // return array of dust objects
  public Dust[] getDust() {
    return dust;
  }

  // paint all dust objects in a level
  public void paint(Graphics g) {
    for (int i=0; i<numOfDust; i++) {
      dust[i].paint(g);
    }
  }

  // update all dust objects in a level. Otherwise start
  //   dust if it's not on screen
  public void update() {
    for (int i=0; i<numOfDust; i++) {
      if (dust[i].isActive()) {
				dust[i].update();
      }
      else {                  // make new dust
				initializePosition(dust[i]);
				dust[i].init();
      }
    }
  }

  public void setNumOfDust(int numOfDust) {
System.out.println(numOfDust + "\t" + maxNumOfDust);
		this.numOfDust = numOfDust;
  }

  public void setSound(boolean s) {
    playSound = s;
  }

  public void playExplosion() {
    if (playSound && expsound != null) {
      expsound.play();
    }
  }
}