
import java.applet.*;
import java.awt.*;

/////////////////////////////////////////////////////////////////
public class TricytremeManager {


  private Tricytreme tr[];           		// array of tricytremes

  boolean playSound = false;         		// initially no sound
  AudioClip expsound;                		// sound clip of explosion

  static int width, height;          		// applet dimensions

  private int startNumOfMinerals = 0;		// Number of TR's that appears at the
  																			// start of the game.

  private int numOfMinerals = 0;				// Number of TR's on the screen.

  // constructor
  public TricytremeManager(int numOfMinerals,int width,int height, Image trImages[],
  												 Image explodeImages[], Applet applet, AudioClip exp) {

    this.width = width;
    this.height =  height;

    tr = new Tricytreme[numOfMinerals];

    for (int i=0; i<tr.length; i++) {
      tr[i] = new Tricytreme(trImages,explodeImages,width,height,this,applet);
    }

    expsound = exp;

    this.startNumOfMinerals = numOfMinerals;
    this.numOfMinerals = numOfMinerals;

    newGame();
  }


  // allow the Tricytreme class to communicate with the ship
  public void initialize(ShipManager gm) {
    Tricytreme.initialize(gm);
  }

  // set tr at a random screen location
  private void initializePosition(Moveable m) {
    m.setPosition(Tricytreme.getRand(width - 100)+50,
    							Tricytreme.getRand(height - 150)+31);
  }

  // initialize parameters of new Game
  public void newGame() {
		this.numOfMinerals = this.startNumOfMinerals ;   // start with startLevel number of Tr's
																		 			 //   on the screen

		for (int i=0; i<tr.length; i++) {
			initializePosition(tr[i]);
			if (i >= numOfMinerals) {      // suspend
				tr[i].suspend();						 // above start numOfMinerals
			}
		}
  }


  // return array of tricytreme
  public Tricytreme[] getTricytreme() {
    return tr;
  }

  // paint all tricytremes in a level
  public void paint(Graphics g) {
    for (int i=0; i<numOfMinerals; i++) {
      tr[i].paint(g);
    }
  }

  // update all tricytremes in a level. Otherwise start
  // tr if it's not on screen
  public void update() {
    for (int i=0; i<numOfMinerals; i++) {
      if (tr[i].isActive()) {
				tr[i].update();
      }
      else {                  // make new tr
				initializePosition(tr[i]);
				tr[i].init();
      }
    }

    for (int i=numOfMinerals; i<tr.length; i++)
    {
			if (tr[i].isActive()) {
				tr[i].suspend();
			}
		}
  }

  public void setNumOfMinerals(int numOfMinerals) {
    this.numOfMinerals = numOfMinerals;
  }

  public void setSound(boolean s) {
    playSound = s;
  }

  public void playExplosion() {
    if (playSound && expsound != null) {
      expsound.play();
    }
  }
}